<?php 

//add notes below tested plugins
function tp_plugin_notes( $tp_file, $tp_data ) {
	global $ptd_options, $tester_key_confirmed, $curr_ip, $curr_user;
	$remove_test_url = admin_url ( 'plugins.php?remove_test=' . $tp_file );
	$remove_test_url = wp_nonce_url( $remove_test_url, 'remove_test' );
	if( $ptd_options['tester_key_method'] == 0 ) {
		$tester_key_method = 'IP address';
		$curr_key_val = $curr_ip;
	} else {
		$tester_key_method = 'user name';
		$curr_key_val = $curr_user;
	}
	$tester_key_text = ( $tester_key_confirmed ? ' (<u>your</u> '.$tester_key_method.').' : '. However, <u>your</u> ' . $tester_key_method . ' is ' . $curr_key_val . '.');
	echo '<tr class="plugin-tested-tr"><td colspan="3" class="plugin-tested">
	<div class="plugin-tested-message">"' . $tp_data[Name] . '" is loaded by <a href="' . PTD_PLUGIN_SETTINGS_URL . '">Plugin Test Drive</a> for ' . $tester_key_method . ' <span class="name">' . $ptd_options['tester_key_val'] . '</span> only' . $tester_key_text . '<a href="' . $remove_test_url . '"><br /><br />Stop testing ' . $tp_data[Name] . '</a></div></td></tr>';
}

//remove activate/delete/edit links for tested plugins
function tp_action_links( $tp_links, $tp_file ) {
	global $ptd_options;
	if( isset( $ptd_options[$tp_file] ) && $ptd_options[$tp_file]['is_tested'] == '1' ) {
		unset( $tp_links['activate'] );
		unset( $tp_links['delete'] );
		unset( $tp_links['edit'] );
		$tp_links = array_values( $tp_links );
		add_action( "after_plugin_row_$tp_file", 'tp_plugin_notes', 10, 2 );
	}
	if( $tp_file == PTD_PLUGIN_FILE ) {
		$settings_link = '<a href="' . PTD_PLUGIN_SETTINGS_URL . '">Settings</a>';
		array_unshift( $tp_links, $settings_link );
	}
	return $tp_links;
}

//prevent updates for tested plugins - for wp 3.0 +
function ptd_prevent_tested_plugin_updates( $r, $url ) {
	global $ptd_options;
	if( 0 === strpos( $url, 'http://api.wordpress.org/plugins/update-check/' ) ) {
		$tp_objects = unserialize( $r['body']['plugins'] );
		foreach( $ptd_options as $ptd_option => $ptd_val ) {
			if( substr( $ptd_option,-4 ) == '.php' && isset( $ptd_options[$ptd_option]['is_tested'] ) )
				unset( $tp_objects->plugins[$ptd_option] );
		}
		$r['body']['plugins'] = serialize( $tp_objects );
	}
	return $r;
}

//prevent updates for tested plugins - for wp 2.8-3.0
function ptd_prevent_tested_plugin_updates_legacy( $value = '' ) {
	global $ptd_options;
	if( ( isset( $value->response ) ) && ( count( $value->response ) ) ) {
		foreach( $value->response as $plugin_idx => $plugin_item ) {
			if( isset( $ptd_options[$plugin_idx]['is_tested'] ) ) 
				unset( $value->response[$plugin_idx] );
		}
	}
	return $value;
}

if( intval( $wp_version ) >= 3 ) {
	set_site_transient( 'update_plugins','' );// for wp 3.0 +. reset plugin database information
	add_filter( 'http_request_args', 'ptd_prevent_tested_plugin_updates', 10, 2 );
} else {
	add_filter( 'transient_update_plugins', 'ptd_prevent_tested_plugin_updates_legacy' ); // for wp 2.8 +
}

//stop testing a plugin
function tp_stop_testing( $tp_remove ) {
	global $ptd_options;
	do_action( 'deactivate_' . trim( $tp_remove ) );
	unset( $ptd_options[$tp_remove] );
	ptd_update_option();
	wp_redirect( admin_url( 'plugins.php?deactivate=true' ) );
}
function ptd_check_test_removal() {
	if( isset( $_GET['remove_test'] ) ) {
		check_admin_referer( 'remove_test' );
		tp_stop_testing( $_GET['remove_test'] );
	}
}

add_action( 'admin_init', 'ptd_check_test_removal' );
add_filter( 'plugin_action_links', 'tp_action_links', 10, 2 );
?>